#include "ap.h"


// Functions to perform bit-reverse ordering of data

size_t permute (size_t n, size_t nn)
{
    size_t p = 1;

    do
    {
        p += p + (n & 1);
        n >>= 1;
    } while (p < nn);

    return p - nn;
}

void scramble (modint data[], size_t nn)
{
    size_t i, j;
    modint tmp;

    for (i = 0; i < nn; i++)
    {
        j = permute (i, nn);
        if (j < i)
        {
            tmp = data[i];
            data[i] = data[j];
            data[j] = tmp;
        }
    }
}

void tablescramble (modint data[], size_t ptable[], size_t nn)
{
    size_t i, j;
    modint tmp;

    for (i = 0; i < nn; i++)
    {
        j = ptable[i];
        if (j < i)
        {
            tmp = data[i];
            data[i] = data[j];
            data[j] = tmp;
        }
    }
}
